PROGRAM_NAME='nx_ipserver_application'
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 09/14/2004  AT: 16:14:39        *)
(***********************************************************)
(*{{PS_SOURCE_INFO(PROGRAM STATS)                          *)
(*  ORPHAN_FILE_PLATFORM: 1                                *)
(*!!FILE REVISION:                                         *)
(*  REVISION DATE: 05/18/2002                              *)
(*                                                         *)
(*  COMMENTS:                                              *)
(*                                                         *)
(***********************************************************)
(*}}PS_SOURCE_INFO                                         *)

DEFINE_DEVICE
dvIP_SERVER = 0:3:0 // WICHTIG - die PORT-Nummer ist der Bezugspunkt fr 
										// die CLIENT und SERVER Befehle!


DEFINE_VARIABLE
CHAR SERVER_BUFFER[3000]
DEV_INFO_STRUCT MASTER_INFO
CHAR USER_IP[20]
INTEGER USER_PORT
IP_ADDRESS_STRUCT MASTER_IP
INTEGER nTERMINAL_PORT = 49999
INTEGER BIN_ONLINE
VOLATILE INTEGER nOBERGURU = 0

VOLATILE INTEGER nPWRMODE = 0    
VOLATILE INTEGER nINPUTMODE = 0    
VOLATILE INTEGER nCMDLEVEL = 0




DEFINE_CALL 'COMMANDLIST'
{
  SEND_STRING dvIP_SERVER,"'------ Device Control Commands ----------------------------',13,10"
  SEND_STRING dvIP_SERVER,"'>PWRx<cr/lf>','         - Power Set x=1 -> On, x00 -> Off',13,10"
  SEND_STRING dvIP_SERVER,"'?PWR<cr/lf>','          - Power Request',13,10"
  SEND_STRING dvIP_SERVER,"'!PWRx<cr/lf>','         - Power Response x=1 -> On, x00 -> Off',13,10"
  SEND_STRING dvIP_SERVER,"'>INPxy<cr/lf>','        - Input Set x=1 -> DATA, x=2 -> VIDEO ',13,10" 
  SEND_STRING dvIP_SERVER,"'                          in DATA Mode: y=1 -> VGA, y=2 -> RGB ',13,10"
  SEND_STRING dvIP_SERVER,"'                          in VIDEO Mode: y=1 -> Composite, y=2 -> Y/C',13,10"
  SEND_STRING dvIP_SERVER,"'                          if y=0 -> Autodetect in Defined Mode',13,10"
  SEND_STRING dvIP_SERVER,"'?INP<cr/lf>','          - Input Request',13,10"
  SEND_STRING dvIP_SERVER,"'!INPxy<cr/lf>','        - Input Response; see Input Set',13,10"
  SEND_STRING dvIP_SERVER,"'-----------------------------------------------------------',13,10" 
  IF(nOBERGURU)
  {
  SEND_STRING dvIP_SERVER,"13,10"
  SEND_STRING dvIP_SERVER,"'----- ... and for the Gurus -------------------------------',13,10"
  SEND_STRING dvIP_SERVER,"'ECHO OFF                - Do not display inputs',13,10"
  SEND_STRING dvIP_SERVER,"'ECHO ON                 - Display inputs',13,10"
  SEND_STRING dvIP_SERVER,"'EXIT                    - Close this terminal session',13,10"
  SEND_STRING dvIP_SERVER,"'FIRMWARE VERSION        - Displays Firmware version string',13,10"
  SEND_STRING dvIP_SERVER,"'REBOOT                  - Reboots the Device after 10 seconds delay',13,10"
  SEND_STRING dvIP_SERVER,"'                          WARNING! This action can',$27,'t be cancelled!!!',13,10"
  SEND_STRING dvIP_SERVER,"'VERSION                 - Displays version string',13,10"
  SEND_STRING dvIP_SERVER,"'WHO                     - Who',$27,'s online?',13,10"
  SEND_STRING dvIP_SERVER,"'-----------------------------------------------------------',13,10"
  }
  IF(nCMDLEVEL = 0)
  {
    SEND_STRING dvIP_SERVER,"'!RDY',13,10"
  }
}






DEFINE_START
GET_IP_ADDRESS (0:0:0,MASTER_IP)
IP_SERVER_OPEN(dvIP_SERVER.Port,nTERMINAL_PORT,1)
CREATE_BUFFER dvIP_SERVER,SERVER_BUFFER
DEVICE_INFO(0:0:0,MASTER_INFO)



DEFINE_EVENT
DATA_EVENT[dvIP_SERVER]
{
  COMMAND:
  {
    SEND_STRING 0,"'Command received: ',Data.Text"
  }
  STRING:
  {
    LOCAL_VAR CHAR sTEMP[100],sSCHROTT[50]
    LOCAL_VAR INTEGER SHOW_ECHO
    CANCEL_WAIT 'SLEEPING'
    IF (SHOW_ECHO = 1)
    {
      SEND_STRING dvIP_SERVER,"DATA.TEXT"
    }
    IF(FIND_STRING(SERVER_BUFFER,"$0D,$0A",1))
    {
      sTEMP = REMOVE_STRING(SERVER_BUFFER,"$0D,$0A",1)
      sTEMP = UPPER_STRING(sTEMP)
      SELECT
      {
        ACTIVE (sTEMP = "'?',13,10"): // Hilfe
        { 
          //nCMDLEVEL = 0
          CALL 'COMMANDLIST'
        }
        ACTIVE (sTEMP = "'REBOOT',13,10"): // Reboot Master
        {
          IF(nCMDLEVEL = 1)
          {
            SEND_STRING dvIP_SERVER,"'Rebooting Device in 10 Seconds. Disconnecting terminal... GoodBye!'"
            IP_SERVER_CLOSE(dvIP_SERVER.Port)
            CANCEL_WAIT 'SLEEPING'
            BIN_ONLINE = 0
            nOBERGURU = 0
            WAIT 100
            {
              REBOOT(0:0:0)
            }
          }
        }
        ACTIVE (sTEMP = "'WHO',13,10"): // Who's online
        { 
          IF(nCMDLEVEL = 1)
          {
            SEND_STRING dvIP_SERVER,"'User ',DATA.SourceIP,' is talking with Device ',MASTER_IP.IPAddress,' on Socket ',ITOA(DATA.SourcePort),13,10"
          }
        }
        ACTIVE (sTEMP = "'FIRMWARE VERSION',13,10"): // Master Version
        { 
          IF(nCMDLEVEL = 1)
          {
            SEND_STRING dvIP_SERVER,"'Firmware Version ',MASTER_INFO.VERSION,13,10"
          }
        }
        ACTIVE (sTEMP = "'VERSION',13,10"): // Version
        {
          IF(nCMDLEVEL = 1)
          {
            SEND_STRING dvIP_SERVER,"'Device Terminal Version 1.0 BETA',13,10"
            SEND_STRING dvIP_SERVER,"'(c) 2002,2004 Marc Scheibein',13,10"
          }
        }
        ACTIVE (sTEMP = "'FUCK',13,10"): // Nana...
        {
          IF(nCMDLEVEL = 1)
          {
            SEND_STRING dvIP_SERVER,"'I',$27,'m not such kind of device!',13,10"
          }
        }
        ACTIVE (sTEMP = "'ECHO ON',13,10"): // Eingabe zurckschicken
        {
          IF(nCMDLEVEL = 1)
          {
            SHOW_ECHO = 1
            SEND_STRING dvIP_SERVER,"13,10"
          }
        }
        ACTIVE (sTEMP = "'ECHO OFF',13,10"): // Eingabe nicht mehr anzeigen
        {
          IF(nCMDLEVEL = 1)
          {
            SHOW_ECHO = 0
            SEND_STRING dvIP_SERVER,"13,10"
          }
        }
        ACTIVE (sTEMP = "'EXIT',13,10"): // Und weg
        {
          IF(nCMDLEVEL = 1)
          {
            SEND_STRING dvIP_SERVER,"'The Guru want',$27,'s to meditate... Goodbye!',13,10"
            IP_SERVER_CLOSE(dvIP_SERVER.Port)
            CANCEL_WAIT 'SLEEPING'
            BIN_ONLINE = 0
            nOBERGURU = 0
          }
        }
        ACTIVE (sTEMP = "'HELLO',13,10"): // Hallo auch
        {
          IF(nCMDLEVEL = 1)
          {
            SEND_STRING dvIP_SERVER,"'How are you doing?',13,10"
          }
        }
        ACTIVE (sTEMP = "13,10"): // nur ein CR/LF
        {
          IF(nCMDLEVEL = 1)
          {
            SEND_STRING dvIP_SERVER,"' ',13,10"
          }
        }
        ACTIVE (sTEMP = "'GURU',13,10"): // User kennt sich aus....
        {
          nCMDLEVEL = 1
          SEND_STRING dvIP_SERVER,"'Working in higher spheres now....',13,10"
          nOBERGURU = 1
        }  
        ACTIVE (sTEMP = "'NOGURU',13,10"): // ... wieder auf Normallevel
        {
          SEND_STRING dvIP_SERVER,"'Coming down to earth....',13,10"
          nOBERGURU = 0
          nCMDLEVEL = 0
          SEND_STRING dvIP_SERVER,"'!RDY',13,10"
        }
        ACTIVE(FIND_STRING(sTEMP,"'>PWR'",1)):
        {
          //nCMDLEVEL = 0
          sSCHROTT = REMOVE_STRING(sTEMP,"'>PWR'",1)
          nPWRMODE = ATOI("sTEMP")
          SEND_STRING dvIP_SERVER,"'!PWR',ITOA(nPWRMODE),13,10"
        }       
        ACTIVE(FIND_STRING(sTEMP,"'?PWR'",1)):
        {
          //nCMDLEVEL = 0
          SEND_STRING dvIP_SERVER,"'!PWR',ITOA(nPWRMODE),13,10"
        }  
        ACTIVE(FIND_STRING(sTEMP,"'>INP'",1)):
        {
          //nCMDLEVEL = 0
          sSCHROTT = REMOVE_STRING(sTEMP,"'>INP'",1)
          nINPUTMODE = ATOI("sTEMP")
          IF(nINPUTMODE < 10)
          {
            nINPUTMODE = nINPUTMODE * 10
          }
          SEND_STRING dvIP_SERVER,"'!INP',ITOA(nINPUTMODE),13,10"
        }       
        ACTIVE(FIND_STRING(sTEMP,"'?INP'",1)):
        {
          //nCMDLEVEL = 0
          SEND_STRING dvIP_SERVER,"'!INP',ITOA(nINPUTMODE),13,10"
        }
        ACTIVE (1):
        {
          SET_LENGTH_ARRAY(sTEMP,LENGTH_ARRAY(sTEMP)-2)
          SWITCH(nCMDLEVEL)
          {
            CASE 0: { SEND_STRING dvIP_SERVER,"'#',sTEMP,13,10" }
            CASE 1: { SEND_STRING dvIP_SERVER,"'Can',$27,'t understand the Guru....',13,10" }
          }
        }
      }
      IF(SHOW_ECHO)
      {
        //SEND_STRING dvIP_SERVER,"':'"
      }
    }
  }
  ONLINE:
  {
    CANCEL_WAIT 'SLEEPING'
    BIN_ONLINE = 1
    USER_IP = DATA.SourceIP
    USER_PORT = DATA.SourcePort 
    nCMDLEVEL = 0
    SEND_STRING dvIP_SERVER,"'A "?" lists supported Commands',13,10"
    SEND_STRING dvIP_SERVER,"'!RDY',13,10" // ready for Communication
(*
    IF(LENGTH_STRING(USER_IP))
      SEND_STRING dvIP_SERVER,"'Hello, User from IP ',USER_IP,' on Port ',ITOA(USER_PORT),'!',13,10"
    ELSE
      SEND_STRING dvIP_SERVER,"'Hello my User!',13,10"
    SEND_COMMAND dvIP_SERVER,"'Welcome to the Fantastic World of IP Work!',13,10"
    SEND_STRING dvIP_SERVER,"'----------------------------------------',13,10"
    SEND_STRING dvIP_SERVER,"'A ',$27,'?',$27,' shows the Command List',13,10"
    SEND_STRING dvIP_SERVER,"13,10"
*)    
  }
  OFFLINE:
  {
    BIN_ONLINE = 0 
    nOBERGURU = 0
    WAIT 50
      IP_SERVER_OPEN(dvIP_SERVER.Port,nTERMINAL_PORT,1)
  }
}
  

DEFINE_PROGRAM
IF(BIN_ONLINE)
  {
  WAIT 400 'SLEEPING'
    {
    IF(nCMDLEVEL = 1)
    {
      SEND_STRING dvIP_SERVER,"'The Guru has left the building... Goodbye!',13,10"
    }
    ELSE
    {
      SEND_STRING dvIP_SERVER,"'!CTO',13,10" // RM "Communication TimeOut"
    }
    IP_SERVER_CLOSE(dvIP_SERVER.Port)
    BIN_ONLINE = 0
    }
  }